<template>
  <q-dialog
    v-model="showDialog"
    persistent
    maximized
    transition-show="slide-left"
    transition-hide="slide-right"
  >
    <q-card
      v-if="nextTermsAndConditions"
      :class="{ 'desktop-modal': isDesktopPlatform, 'mobile-modal': !isDesktopPlatform }"
      class="column no-wrap terms"
    >
      <q-card-section class="text-white bg-primary">
        <div class="text-h6">
          {{ title }}
        </div>
      </q-card-section>

      <q-card-section v-if="shortDescription || nextTermsAndConditions.url">
        <div
          class="text-body1"
          v-if="shortDescription"
        >
          {{ shortDescription }}
        </div>
        <div
          class="text-body1"
          v-if="nextTermsAndConditions.url"
        >
          <a
            :href="nextTermsAndConditions.url"
            target="_blank"
            rel="noopener noreferrer"
          >{{ nextTermsAndConditions.url }}</a>
        </div>
      </q-card-section>

      <q-separator v-if="shortDescription || nextTermsAndConditions.url" />

      <q-card-section
        v-if="htmlContent"
      >
        <div
          class="text-body2"
          v-html="htmlContent"
        />
      </q-card-section>
      <q-space />

      <q-separator />

      <q-card-actions
        align="right"
        class="q-px-lg q-py-md"
      >
        <q-btn
          :label="$gettext('Logout')"
          @click="onClickLogoutButton"
        />

        <q-btn
          color="primary"
          :label="$gettext('I agree')"
          @click="onClickAgreeButton"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import queryTermsAndConditions from 'src/components/terms-and-conditions/graphql/queryTermsAndConditions'
import mutationInsertUserTermsAndConditionsConsent from 'src/components/terms-and-conditions/graphql/mutationInsertUserTermsAndConditionsConsent'
import { getI18nField } from 'src/services/translate'

export default {
  name: 'TermsAndConditionsModal',
  mixins: [
    PlatformMixin,
    DateMixin
  ],
  data () {
    return {
      showDialog: false
    }
  },
  apollo: {
    termsAndConditions: {
      query: queryTermsAndConditions,
      notifyOnNetworkStatusChange: true,
      pollInterval: 60000
    }
  },
  computed: {
    nextTermsAndConditions () {
      return this.termsAndConditions?.[0]
    },
    title () {
      return getI18nField(this.nextTermsAndConditions, 'title')
    },
    shortDescription () {
      return getI18nField(this.nextTermsAndConditions, 'short_description')
    },
    htmlContent () {
      return getI18nField(this.nextTermsAndConditions, 'html_content')
    }
  },
  watch: {
    nextTermsAndConditions (newVal) {
      this.$nextTick(() => {
        // wrap it into nextTick to show dialog transitions
        this.showDialog = Boolean(newVal)
        this.$store.commit('appState/setTermsAndConditionsModalOpen', this.showDialog)
      })
    }
  },
  methods: {
    onClickAgreeButton () {
      const consentRequestId = this.nextTermsAndConditions.id
      this.$apollo.mutate({
        mutation: mutationInsertUserTermsAndConditionsConsent,
        variables: {
          consentRequestId
        },
        refetchQueries: ['termsAndConditions']
      }).then(() => {
        this.showDialog = false
      }).catch(e => {
        console.error('Could not insert user consent', e)
        this.$q.notify({
          message: this.$gettext('There was an error while accepting terms and conditions.'),
          color: 'negative'
        })
      })
    },
    onClickLogoutButton () {
      this.$router.push({ name: 'logout' })
    }
  }
}
</script>

<style scoped>
.desktop-modal {
  min-width: 560px;
}
.mobile-modal {
  min-width: 280px;
}
.terms :deep(h1) {
  font-size: 2rem;
  line-height: 2rem;
}
.terms :deep(h2) {
  font-size: 1.5rem;
  line-height: 1.5rem;
}
.terms :deep(h3) {
  font-size: 1.4rem;
  line-height: 1.4rem;
}
.terms :deep(h4) {
  font-size: 1.3rem;
  line-height: 1.3rem;
}
.terms :deep(h5) {
  font-size: 1.2rem;
  line-height: 1.2rem;
}
.terms :deep(h6) {
  font-size: 1.1rem;
  line-height: 1.1rem;
}
</style>
